// -*- c++ -*-
#if !defined(SharedMemConfig_H)
#define SharedMemConfig_H

namespace shm_config
{

// Note: enums are also parsed by ../tools/shm2py.py
enum
{
    SHM_OPT_EmulateMidButtonTime,
    SHM_OPT_xPadMin,
    SHM_OPT_xPadMax,
    SHM_OPT_xCenterNumerator,
    SHM_OPT_xCenterDenominator,
    SHM_OPT_xEdgeNumerator,
    SHM_OPT_xEdgeDenominator,
    SHM_OPT_xJump,
    SHM_OPT_yPadMin,
    SHM_OPT_yPadMax,
    SHM_OPT_yCenterNumerator,
    SHM_OPT_yCenterDenominator,
    SHM_OPT_yEdgeNumerator,
    SHM_OPT_yEdgeDenominator,
    SHM_OPT_yJump,
    SHM_N_VALUES,
};

enum
{   
    SHM_KEY = 23948 // successor to SHM_SYNAPTICS
};


class Handler
{
 public:
    class MailBox
    {
     public:
        MailBox() : cmd(0) {}
        int  cmd;
        int  options[SHM_N_VALUES];
    };

    static Handler* create() { return new Handler; }
    ~Handler();

    bool  ok()  const { return _mailBox != 0; }
    int   key() const { return _key; } // most likely ==SHM_KEY
    int   id()  const { return _id; }
    const MailBox  *mailBox() const { return _mailBox; }
          MailBox  *mailBox()       { return _mailBox; }

 private:
    Handler();
    Handler(const Handler&);
    Handler& operator=(const Handler&);
    int      _key;
    int      _id;
    MailBox  *_mailBox;
}; // Handler

} // namespace shm_config

#endif /* SharedMemConfig_H */
