#!/usr/bin/env python
#
# Author:  Yotam Medini  yotam.medini@gmail.com -- Created: 2009/October/03
#

import sys
import string

cmd_option = sys.argv[1]
if cmd_option == '-s':
    sys.stdout.write("\nnames = {}\n")
n_in = n_out = 0
for line in sys.stdin.readlines():
    n_in += 1
    ss = string.split(line)
    if len(ss) > 0 and ss[0][:4] == 'SHM_':
        n_out += 1
        name = ss[0]
        if name[-1] == ',':
            name = name[:-1]
        if cmd_option == '-n':
            sys.stdout.write("WRITE_ASSIGNMENT(%s);\n" % name)
        elif cmd_option == '-s':
            if name[:8] == 'SHM_OPT_':
                sys.stdout.write("names[%s] = '%s'\n" % (name, name[8:]))
        else:
            sys.stderr.write("Bad optin: %s\n" % cmd_option)
            sys.exit(1)
sys.stderr.write("input/output lines: %d / %d\n" % (n_in, n_out))
sys.exit(0)
